<?php

namespace SplitTestForElementor\Classes\Misc;

class SettingsManager {

	const PREFIX = "rocket_split_test";
	const CACHE_BUSTER_ACTIVE = "cache_buster_active";

	private static $config = [
		SettingsManager::CACHE_BUSTER_ACTIVE => ['default' => false, 'type' => 'boolean'],
	];

	/** @var LicenceManager */
	private $licenceManager;

	public function __construct()
	{
		$this->licenceManager = new LicenceManager();
	}
	public function getValue($key) {
		return esc_attr($this->getRawValue($key));
	}

	public function registerSettings() {
		$key = self::CACHE_BUSTER_ACTIVE;
		add_option( self::PREFIX."_".$key, self::$config[$key]['default']);
		register_setting( 'split_test_for_elementor_options_group', self::PREFIX."_".$key, ['type' => self::$config[$key]['type']]);
	}

	public function getRawValue($key) {
		if (!isset(self::$config[$key])) {
			// TODO@kberlau: return false if boolean
			return null;
		}
		// TODO@kberlau: Return defaults if pro is not active
		$value = get_option(self::PREFIX."_".$key, null);
		if ($value == null || empty(trim($value))) {
			return self::$config[$key]['default'];
		}
		return $value;
	}

}